/* eslint-disable */ 
<template>
  <div>
    <b-form @submit="onSubmit" @reset="onReset">
      <b-container fluid class="m-0 p-0">
        <b-form-row>
          <b-col cols="4">
            <b-form-group label="Mass" label-for="mass-input">
              <b-form-input id="mass-input" v-model="form.mass"></b-form-input>
            </b-form-group>
            <b-form-group label="Motor Mass" label-for="motor-mass-input">
              <b-form-input id="motor-mass-input" v-model="form.motor_mass"></b-form-input>
            </b-form-group>
          </b-col>
          <b-col cols="4">
            <b-form-group label="Diameter" label-for="diameter-input">
              <b-form-input id="diameter-input" v-model="form.diameter"></b-form-input>
            </b-form-group>
            <b-form-group label="Motor Total Impulse" label-for="total-impulse-input">
              <b-form-input id="total-impulse-input" v-model="form.motor_tot_imp"></b-form-input>
            </b-form-group>
          </b-col>
          <b-col cols="4">
            <b-form-group label="Approximate Drag Coefficient" label-for="drag-coeff-input">
              <b-form-input id="drag-coeff-input" v-model="form.drag_coeff"></b-form-input>
            </b-form-group>
            <b-form-group label="Motor Thrust Curve File" label-for="thrust-curve-input">
              <b-form-file
                id="thrust-curve-input"
                :state="Boolean(form.thrust_curve_file)"
                placeholder="Choose a file or drop it here..."
                drop-placeholder="Drop file here..."
                v-model="form.thrust_curve_file"
              ></b-form-file>
            </b-form-group>
          </b-col>
        </b-form-row>
      </b-container>
      <b-button type="reset" variant="danger">Reset</b-button>
      <b-button type="submit" variant="primary">Simulate</b-button>
    </b-form>
    <hr />
    <div v-if="results">
      <b-container fluid class="pr-0 pl-0">
        <b-row>
          <b-col>
            <h5>Apogee</h5>
            <p>{{apogee}} ft</p>
          </b-col>
          <b-col>
            <h5>Flight Time</h5>
            <p>{{time_of_flight}} s</p>
          </b-col>
        </b-row>
        <b-row>
          <b-col>
            <h5>Maximum Velocity</h5>
            <p>
              {{max_veloc}} ft&middot;s
              <sup>-1</sup>
            </p>
          </b-col>
          <b-col>
            <h5>Maximum Acceleration</h5>
            <p>
              {{max_accel}} ft&middot;s
              <sup>-2</sup>
            </p>
          </b-col>
        </b-row>
        <b-row>
          <b-col>
            <h5>Final Mass</h5>
            <p>{{final_mass}} lbm</p>
          </b-col>
        </b-row>
      </b-container>
    </div>
    <div v-else-if="no_results">
      <h3>Hmm, something went wrong.</h3>
    </div>
  </div>
</template>

<script>
var numeral = require("numeral");
let axios = require("axios");
axios.defaults.baseURL = "http://localhost:6001";

export default {
  name: "SimpleOneDOF",
  data() {
    return {
      form: {
        mass: 0,
        diameter: 0,
        drag_coeff: 0.6,
        motor_tot_imp: 0,
        motor_mass: 0,
        thrust_curve_file: null
      },
      results: null,
      no_results: null,
      time_of_flight: 0,
      apogee: 0,
      max_accel: 0,
      max_veloc: 0,
      final_mass: 0
    };
  },
  methods: {
    onSubmit() {
      axios
        .post("/simple-3dof", this.form)
        .then(resp => {
          this.results = true;
          var data = resp.data;
          this.time_of_flight = numeral(data.time_of_flight).format("0,0.00");
          this.apogee = numeral(data.apogee).format("0,0.00");
          this.max_accel = numeral(data.max_acceleration).format("0,0.00");
          this.max_veloc = numeral(data.max_velocity).format("0,0.00");
          this.final_mass = numeral(data.final_mass).format("0,0.00");
        })
        .catch(err => {
          console.log(err);
          this.no_results = true;
        });
    },
    onReset() {
      this.msg = "";
      this.form.mass = 0;
      this.form.diameter = 0;
      this.form.drag_coeff = 0.6;
      this.form.thrust_curve_file = null;
      this.results = false;
      this.no_results = false;
    }
  }
};
</script>

<style>
</style>